! ----------------------------------------------------------------------
! *   solve decomposed eqation by forward and backward substitution    *
! ----------------------------------------------------------------------
      subroutine gausssv ( a, b, x, ip, n )

      implicit none
      real(8):: a(n,n), b(n), x(n)
      real(8):: SAx
      integer:: ip(n)
      integer:: n
      integer:: i,j,k

!  ****    forward elimination    ****

      do k = 1,n
        x(k) = b(ip(k))
      end do

      do k = 1, n-1
        x(k) = x(k) / a(ip(k),k)
        do i = k+1,n
          x(i) = x(i) - a(ip(i),k) * x(k)
        end do
      end do

!  ****    Backward substitution    ****

      x(n) = x(n) / a(ip(n),n)

      do k = n-1, 1, -1
        SAx = 0.0d0
        do i = k+1, n
          SAx = SAx + a(ip(k),i) * x(i)
        end do
        x(k) = x(k) - SAx
      end do

      return
      end subroutine gausssv

