! ----------------------------------------------------------------------
! *   A sample program to solve linear equation systems                *
! *               by Gaussian elimination method                       *
! ----------------------------------------------------------------------
      program leqsys

      implicit none

      real(8), allocatable:: a(:,:), b(:), x(:)
      integer, allocatable:: ip(:)
      integer:: n
      integer:: i,j,k

!   number of dimension

!      read(5,*) n
      n = 3

!   allocate dimension variables

      allocate ( a(n,n), b(n), x(n) )
      allocate ( ip(n) )

!  *****     Set coefficient     *****

      a(1,1) =  2.0d0
      a(1,2) =  2.0d0
      a(1,3) = -2.0d0
      a(2,1) =  3.0d0
      a(2,2) =  5.0d0
      a(2,3) = -7.0d0
      a(3,1) =  2.0d0
      a(3,2) = -3.0d0
      a(3,3) =  1.0d0

!  *****     Set RHS vector     *****

      b(1)   =  4.0d0
      b(2)   =  0.0d0
      b(3)   =  5.0d0

      do k = 1,n
        write (*,*) (a(k,j),j=1,n),b(k)
      end do

!  *****     decomposition: A -> LU     *****

      call       gausslu( a, ip, n )

!  *****     Substitution: x = (LU)**(-1)*b     *****

      call       gausssv( a, b, x, ip, n )

!  *****     Write result     *****

      do k = 1,n
        write (*,*) 'x(',k,' ) = ',x(k)
      end do

      stop
      end program leqsys
